Crafty.c("MapData", {
	_imgd: [],
	_floor: [],
	init: function() {
	},
	MapData: function(image) {
		var context = Crafty.canvas.context;
		context.drawImage(Crafty.asset(image), 0, 0);
		this._imgd = context.getImageData(0, 0, 640, 480);
		
		var data = this._imgd.data;
		var amt = this._imgd.width * this._imgd.height;
		
		var floorTypes = {
			255: "blue",
			16776960:"yellow",
			65280: "green",
			16711680: "red"
		};
		
		for(var i = 0, pos = 0; i<amt; i++, pos+=4)
		{
			pixel = data[pos] * 65536 + data[pos+1] * 256 + data[pos+2]
			this._floor[i] = floorTypes[pixel];
		}
		return this;
	},
	getPixel: function(x, y) {
		var pos = (x+y*this._imgd.width);
		if(x<0||y<0||x>this._imgd.width||y>this._imgd.height) {
			return undefined;
		}
		return this._floor[pos];
	},
	getSpeed: function(x, y) {
		var color = this.getPixel(parseInt(x), parseInt(y));
		var floorSpeeds = {
			"green": 0.6,
			"red": 0.3,
			"yellow": 1.0,
			"blue": 0.2,
		};
		return floorSpeeds[color]||1.0;
	}
});