Crafty.c("Route", {	
	_points: [],
	init: function() {
		this.requires("2D, Canvas");
		this.bind("Draw", function(e) {
			var ctx = e.ctx;
			ctx.lineWidth = 3;
			ctx.lineCap = "round";
			ctx.lineJoin = "round";
			if(this._points.length>1) {
				ctx.beginPath();
				ctx.moveTo(this._points[0].realX, this._points[0].realY);
				for(var i = 1; i<this._points.length; i++) {
					ctx.lineTo(this._points[i].realX, this._points[i].realY);
				}
				ctx.stroke();
			}
		});
	},
	tryRemove: function(who) {
		var pos = this._points.indexOf(who);
		if(pos===-1||pos===0) {return false;}
		this._points.splice(pos, 1);
		this.calculateBounds();
		this.trigger("Change");
		return true;
	},
	routeLength: function() {
		return this._points.length;
	},
	toArray: function() {
		var arr = [];
		for(var i = 0; i<this._points.length; i++) {
			arr.push({x: this._points[i].realX, y: this._points[i].realY, type: this._points[i].type});
		}
		return arr;
	},
	calculateBounds: function() {
		var points = this._points;
		if(points.length<1) {
			return this;
		}
		minX = points[0].realX;
		minY = points[0].realY;
		maxX = points[0].realX;
		maxY = points[0].realY;
		for(var i = 0; i<points.length; i++) {
			if(points[i].realX < minX) {minX = points[i].realX;}
			if(points[i].realX > maxX) {maxX = points[i].realX;}
			if(points[i].realY < minY) {minY = points[i].realY;}
			if(points[i].realY > maxY) {maxY = points[i].realY;}
		}
		this.x = minX-2;
		this.y = minY-2;
		this.w = maxX-minX+4;
		this.h = maxY-minY+4;	
		return this;
	},
	addPoint: function(point) {
		this._points.push(point);
		this.calculateBounds();
		return this;
	},
	fromArray: function(arr) {
		this._points = [];
		for(var i = 0; i<arr.length; i++) {
			this._points.push({realX: arr[i].x, realY: arr[i].y, type: arr[i].type });
		}
		this.ready = true;
		this.calculateBounds();
		return this;
	},
	Route: function(first) {
		
		this._points = [];
		this._points.push(first);
		this.calculateBounds();
		this.ready = true;
		return this;
	}
})