Crafty.c("Runner", {
	_explosionFrames: 0,
	_mapFrames: 0,
	init: function() {
		this.requires("2D, Canvas, Collision, Sprite");		//this.collision([this.origin.x-6,this.origin.y-6],[this.origin.x+6,this.origin.y-6],[this.origin.x+6,this.origin.y+6],[this.origin.x-6,this.origin.y+6]);
		this.collision([9,28],[22,28],[22,32],[9,32])
		this.bind("EnterFrame", function() {
			if(this._point<this._route.length-1) {
				var cur = this._route[this._point];
				var next = this._route[this._point+1];
				var dx = cur.x-next.x;
				var dy = cur.y-next.y;
				var length = Math.sqrt(dx*dx+dy*dy);
				var k = this._progress / length;
				var angle = Math.atan2(dy, dx)/Math.PI*180.0+180+45+90;
				
				var ik = 1.0-k;
				this.x = cur.x*ik+next.x*k-this._origin.x;
				this.y = cur.y*ik+next.y*k-this._origin.y;
				var speed = this._mapdata.getSpeed(this.x+this._origin.x, this.y+this._origin.y);
				if(this._mapFrames>0) {
					speed = 1.0;
					this._mapFrames--;
				}
				if(this.onBridge()) {speed = 1.2;}
				if(this.onCaltrops()) {speed*=0.5;}
				if(this._explosionFrames>0) {
					speed = 0;
					this._explosionFrames--;
				}
				this._progress+=speed;
				var frame = Math.round(this._progress/2.0) % 3;
				var dir = Math.floor(angle/90.0);
				var dirSheet = {0: 1, 1:1, 2:0, 3:3, 4:2, 5:1};
				this.sprite(frame, dirSheet[dir], 1, 1);
				if(this._progress>length) {
					this._progress-=length;
					this._point++;
					var actions = {
						"Dynamite": function() {
							Crafty.e("Dynamite").Dynamite(this.x+this._origin.x, this.y+this._origin.y);
						},
						"Caltrops": function() {
							Crafty.e("Caltrops").Caltrops(this.x+this._origin.x, this.y+this._origin.y);
						}
					}
					
					var action = actions[next.type];
					if(action) {
						action.call(this);
					}
				}
			} else {
				var cur = this._route[this._point];
				this.x = cur.x-this._origin.x;
				this.y = cur.y-this._origin.y;
				if(!this.done) {
					this.done = true;
					Finishers.push(this._player.name);
					if(this.checkFinished()) {
						Crafty.scene("results");
					}
				}
			}
		});
	},
	onBridge: function() {
		collisions = this.hit("Bridge");
		return collisions.length>0;
	},
	onCaltrops: function() {
		collisions = this.hit("Caltrops");
		return collisions.length>0;
	},
	checkFinished: function() {
		runners = Crafty("Runner");
		for(var i = 0; i<runners.length; i++) {
			runner = Crafty(runners[i]);
			if(!runner.done) {
				return false;
			}
		}
		return true;
	},
	
	Runner: function(player, mapdata) {
		this._route = player.path;
		this._player = player;
		this._mapdata = mapdata;
		this._point = 0;
		this._progress = 0.0;
		this.sprite(0,0,1,1);
		this.origin(this.w/2,this.h);
		
	}
});