/* Global stuff */

var Home = {x: 0, y: 0};
var Checkpoints = [];
var Players = [];
var CurrentPlayer = 0;
var Finishers = [];

/* Network stuff */

function LobbyPlayer(uid, name, status){
	this.uid = uid;
	this.name = name;
	this.status = status;
}
var LobbyPlayers = {}; //key=uid; field: LobbyPlayer
var MultiGamePlayers = {}; //key=uid; fields: .name
var MultiGamePlayerList = []; //List; fields: .uid, .name
var MyID = 0;
var MyName = "No Name";
var Socket = null; // If not null, this is a multiplayer game

// Select a random name
var namealternatives = ['Heebo', 'Hank', 'Nakki', 'Batman'];
MyName = namealternatives[Math.floor(Math.random()*namealternatives.length)] + Math.floor(Math.random()*9+1);

var PlotTimeoutText = undefined;

function sendPlayerName(name) {
	if(Socket)
		Socket.emit('update_name', {name: name});
}

function startLobby() {
	Socket = io.connect(":8082");
	
	// Start connection
	//Socket.emit('request_game'

	LobbyPlayers[0] = new LobbyPlayer(0, "-- No players --");
	// Update multiplayer_lobby scene with player names
	Crafty.scene("multiplayer_lobby");
	
	// Socket callbacks

	Socket.on("connect", function(){
		sendPlayerName(MyName);
	});
	Socket.on("disconnect", function(){
	});
	Socket.on("alert", function(msg){
		alert(msg);
	});
	Socket.on("assign_id", function(data){
		MyID = data.id;
	});
	Socket.on("kick", function(data){
		Crafty.scene("multiplayer_lobby");
	});
	Socket.on("lobby_names", function(data){
		console.log("lobby_names data: "+dump(data));
		LobbyPlayers = {}
		for(var i in data){
			var info = data[i]; // id, name, status
			if(info.id == MyID)
				info.name = info.name + " <- you";
			LobbyPlayers[info.id] =
					new LobbyPlayer(info.id, info.name, info.status);
		}
		
		if(Crafty._current == "multiplayer_lobby" ||
				Crafty._current == "multiplayer_wait_stuff"){
			// Update multiplayer_lobby scene with player names
			Crafty.scene("multiplayer_lobby");
		}
	});
	Socket.on("startup_info", function(data){
		console.log("startup_info data: "+dump(data));
		var map_spec = data.map_spec;
		var players = data.players;

		CurrentMap = MapList[map_spec.index];
		Home = map_spec.home;
		Checkpoints = map_spec.checkpoints;

		MultiGamePlayers = {}
		MultiGamePlayerList = []
		for(var uid in players){
			MultiGamePlayers[uid] = {
				name: players[uid].name,
			};
			MultiGamePlayerList.push({
				uid: uid,
				name: players[uid].name,
			});
		}
		
		// Set a single player for setting the route points
		var num = 1;
		Players = [];
		for(var i = 0; i<num; i++) {
			Players.push({name: MyName, path: undefined, runner: undefined, sprite: "character"+i});
		}

		Crafty.scene("turn");
	});
	Socket.on("all_paths", function(data){
		console.log(data);
		var all_paths = data.all_paths;
		// Start a game with the correct amount of players
		Players = [];
		var i = 0;
		for(var uid in all_paths){
			var path = all_paths[uid].path;
			var lobbyplayer = LobbyPlayers[uid];
			Players.push({name: lobbyplayer.name, path: path,
					runner: undefined, sprite: "character"+i});
			i++;
		}
		Crafty.scene("multiplayer_preplay");
	});
	Socket.on("status", function(data){
		if(PlotTimeoutText){
			PlotTimeoutText.text("Time limit: "+data.timeout_timer+"s");
		}
	});
}

function startMultiplayer() {
	Socket.emit('request_game', {});
	Crafty.scene("multiplayer_wait_stuff");
}

function sendPath() {
	Socket.emit('path', {path: Players[0].path});
}

/* Other stuff */

function addPlayerNameList(){
	var str = "";
	var j = 0;
	for(var i in MultiGamePlayerList){
		var player = MultiGamePlayerList[i];
		str = player.name;
		if(player.uid == MyID)
			str = str + " <- you";
		Crafty.e("2D, DOM, Text").attr({x: 30, y: 0+30*j, w: 150, h: 30}).textColor('#ffffff').text(str);
		Crafty.e("2D, Canvas, character"+j).attr({x: 0, y: 30*j});
		j++;
	}
}

var MapData = {};

window.onload = function() {
	Crafty.init(640, 480);
	Crafty.canvas.init();
	
	Crafty.sprite(16, 16, "sprites/rasti.png", {
		rasti: [0, 0], 
	} ); 
	Crafty.sprite(16, 16, "sprites/runner.png", {
		runner: [0, 0], 
	} ); 
	Crafty.sprite(16, 16, "sprites/checkpoint.png", {
		checkpoint: [0, 0], 
	} ); 
	Crafty.sprite(55, 40, "sprites/cabin_01.png", {
		home: [0, 0], 
	} ); 
	Crafty.sprite(16, 16, "sprites/bridge.png", {
		bridge: [0, 0], 
	} ); 
	Crafty.sprite(16, 16, "sprites/dynamite.png", {
		dynamite: [0, 0], 
	} ); 
	Crafty.sprite(32, 32, "sprites/explosion.png", {
		explosion: [0, 0], 
	} );  
	Crafty.sprite(32, 32, "sprites/caltrops_effect_01.png", {
		caltrops: [0, 0], 
	} );  
	Crafty.sprite(32, 32, "sprites/caltrops_icon_01.png", {
		caltropsicon: [0, 0], 
	} );   
	Crafty.sprite(32, 32, "sprites/item_tnt.png", {
		dynamiteicon: [0, 0], 
	} );  
	Crafty.sprite(32, 32, "sprites/delete_icon_01.png", {
		removeicon: [0, 0], 
	} ); 
	Crafty.sprite(8, 8, "sprites/waypoint.png", {
		waypoint: [0, 0], 
	} );
	Crafty.sprite(640, 480, "sprites/menu_08.jpg", {
		menu: [0, 0], 
	} ); 
	Crafty.sprite(300, 250, "sprites/lobby_bg.png", {
		lobby_bg: [0, 0], 
	} ); 
	Crafty.sprite(269, 128, "sprites/help.png", {
		helpbutton: [0, 0], 
	} ); 
	Crafty.sprite(269, 129, "sprites/start.png", {
		startbutton: [0, 0], 
	} ); 
	Crafty.sprite(269, 129, "sprites/multiplayer.png", {
		startlobbybutton: [0, 0], 
	} ); 
	Crafty.sprite(269, 129, "sprites/start.png", {
		startmultibutton: [0, 0], 
	} ); 
	Crafty.sprite(22, 25, "sprites/left.png", {
		leftbutton: [0, 0], 
	} ); 
	Crafty.sprite(21, 25, "sprites/right.png", {
		rightbutton: [0, 0], 
	} ); 
	Crafty.sprite(150, 28, "sprites/back_to_menu.png", {
		backtomenubutton: [0, 0], 
	} ); 
	Crafty.sprite(262, 257, "sprites/cloud_01.png", {
		cloud: [0, 0], 
	} ); 
	Crafty.sprite(16, 35, "sprites/flags.png", {
		flags: [0, 0], 
	} ); 
	Crafty.sprite(32, 32, "sprites/character_00.png", {
		character0: [0, 0], 
	} ); 
	Crafty.sprite(32, 32, "sprites/character_01.png", {
		character1: [0, 0], 
	} ); 
	Crafty.sprite(32, 32, "sprites/character_02.png", {
		character2: [0, 0], 
	} ); 
	Crafty.sprite(32, 32, "sprites/character_03.png", {
		character3: [0, 0], 
	} ); 
	Crafty.sprite(32, 32, "sprites/character_04.png", {
		character4: [0, 0], 
	} ); 
	Crafty.sprite(32, 32, "sprites/character_06.png", {
		character5: [0, 0], 
	} ); 
	Crafty.sprite(32, 32, "sprites/character_08.png", {
		character6: [0, 0], 
	} ); 
	Crafty.sprite(32, 32, "sprites/character_09.png", {
		character7: [0, 0], 
	} ); 
	Crafty.sprite(32, 32, "sprites/character_10.png", {
		character8: [0, 0], 
	} ); 
	
	Crafty.scene("loading", function() {
		load = ["sprites/tutorial_page1_01.jpg","sprites/tutorial_page2_01.jpg","sprites/tutorial_page3_01.jpg","sprites/tutorial_page4_01.jpg"]
		for(var i in Crafty.assets) {
			load.push(i);
		}
		for(var i = 0; i<MapList.length; i++) {
			load.push(MapList[i].bg);
			load.push(MapList[i].data);
		}
		Crafty.load(load, function() {
			Crafty.scene("setup");
		} ); 
	} );
	
	Crafty.scene("setup", function() {
		background = Crafty.e("2D, Canvas, menu")
		Crafty.e("2D, Canvas, Wobble, helpbutton").attr({x: 350, y: 318 }).origin("center").bind("Click", function() {Crafty.scene("tutorial");}).Wobble(1, 12.25);
		Crafty.e("2D, Canvas, Wobble, startbutton").attr({x: 21, y: 318 }).origin("center").bind("Click", function() {startPlaying();}).Wobble(1, 12.25);
		Crafty.e("2D, Canvas, Wobble, startlobbybutton").attr({x: 21, y: 200 }).origin("center").bind("Click", function() {startLobby();}).Wobble(1, 12.25);
		
	});
	
	Crafty.scene("multiplayer_lobby", function() {
		background = Crafty.e("2D, Canvas, menu")
		Crafty.e("2D, Canvas, lobby_bg").attr({x: 10, y: 200});
		var i = 0;
		for(var uid in LobbyPlayers){
			var lobbyplayer = LobbyPlayers[uid];
			var str = lobbyplayer.name;
			if(lobbyplayer.status != "")
				str += "("+lobbyplayer.status+")";
			Crafty.e("2D, DOM, Text").attr({x: 50, y: 215+i*30, w: 300}).textColor('#000000').text(function(){ return lobbyplayer.name; });
			i++;
		}
		Crafty.e("2D, Canvas, Wobble, startmultibutton").attr({x: 341, y: 320 }).origin("center").bind("Click", function() {startMultiplayer();}).Wobble(1, 12.25);
	});
	
	Crafty.scene("multiplayer_wait_stuff", function() {
		background = Crafty.e("2D, Canvas, menu")
		Crafty.e("2D, DOM, Text").attr({x: 50, y: 150, w: 300}).textColor('#000000').text("Waiting for data...");
	});
	
	Crafty.scene("randomize", function() {
		CurrentMap = MapList[Math.floor(Math.random()*MapList.length)];
		Home.x = Math.random()*600+20;
		Home.y = Math.random()*(480-35)+35;
		Checkpoints = [
			{x: Math.random()*600+20, y:Math.random()*(480-35)+35},
			{x: Math.random()*600+20, y:Math.random()*(480-35)+35},
			{x: Math.random()*600+20, y:Math.random()*(480-35)+35},
			//{x: Math.random()*600+20, y:Math.random()*(480-35)+35},
			//{x: Math.random()*600+20, y:Math.random()*(480-35)+35}
		];
		Crafty.scene("turn");
	});
	
	Crafty.scene("turn", function() {
		Crafty.background("rgb(0,0,0)");
		Crafty.e("2D, DOM, Text").attr({x: Crafty.viewport.width/2.0, y: Crafty.viewport.height/2.0, w: 100}).text(Players[CurrentPlayer].name).css("textAlign","center");
		Crafty.e("Delay").delay(function() {Crafty.scene("plot");}, 1000);
	})
	
	Crafty.scene("plot", function() {
		Crafty.DrawManager.draw();
		background = Crafty.e("Mouse, Map").bind("Click",function(e) {
			//console.log(e);
			if(WaypointMenu) {
				WaypointMenu.destroy();
				WaypointMenu = false;
			}
			
			var point = Crafty.e("Waypoint").Waypoint(e.realX, e.realY, this._route);
			this._route.addPoint(point);
			
		})
		route = Crafty.e("2D, Route").Route(Crafty.e("Waypoint").Waypoint(Home.x, Home.y));
		
		var home = Crafty.e("Checkpoint, home").origin("bottom center").Wobble(1.0,22.5).Checkpoint(Home.x, Home.y, route);
		for(var i = Checkpoints.length-1; i>=0; i--) {
			var prev = Crafty.e("Checkpoint, flags").origin("bottom center").Wobble(1.0,22.5).sprite(i, 0, 1, 1).Checkpoint(Checkpoints[i].x, Checkpoints[i].y, route, (i==0), (prev?prev:home));
		}
		background.attr({_route: route}).Map(CurrentMap, route);;
		
		// Add player name list on screen
		addPlayerNameList();
		
		if(Socket)
			PlotTimeoutText = Crafty.e("2D, DOM, Text").attr({x: 300, y: 0, w: 200}).text("--Time limit--");
	} );
	Crafty.scene("preplay", function() {
		Crafty.background("rgb(0,0,0)");

		// If multiplayer, send waypoints to server and act when they arrive
		if(Socket){
			Crafty.e("2D, DOM, Text").attr({x: 160, y: 220, w: 350}).textColor('#ffffff').text("Waiting for other players ("+(MultiGamePlayerList.length-1)+")...");
			sendPath();
			
			// Add player name list on screen
			addPlayerNameList();
	
			PlotTimeoutText = Crafty.e("2D, DOM, Text").attr({x: 300, y: 0, w: 200}).text("--Time limit--");
		}
		// Else start normal game
		else{
			Crafty.e("Delay").delay(function() {Crafty.scene("play");}, 1000);
		}
	});
	// This is the real multiplayer preplay screen
	Crafty.scene("multiplayer_preplay", function() {
		Crafty.background("rgb(0,0,0)");
		Crafty.e("Delay").delay(function() {Crafty.scene("play");}, 1000);
	});
	Crafty.scene("play", function() {
		mapdata = Crafty.e("MapData").MapData(CurrentMap.data);
		background = Crafty.e("Map").Map(CurrentMap);
		Crafty.e("Checkpoint, home").origin("bottom center").Checkpoint(Home.x, Home.y);
		for(var i = 0; i<Checkpoints.length; i++) {
			Crafty.e("Checkpoint, checkpoint, flags").origin("bottom center").sprite(i, 0, 1, 1).Checkpoint(Checkpoints[i].x, Checkpoints[i].y);
		}
		for(var i = 0; i<Players.length; i++) {
			player = Players[i];
			Crafty.e("Runner, "+player.sprite).Runner(player, mapdata);
			//Crafty.e("Route").fromArray(player.path);
		}
		
		// Add player name list on screen
		addPlayerNameList();
	} );
	
	Crafty.scene("results", function() {
		// If multiplayer, go to lobby
		if(Socket){
			Socket.emit('ready', {});
			Crafty.scene("multiplayer_lobby");
		}
		// Else act just like before (start a new game)
		else{
			Crafty.scene("randomize");
		}
		Finishers = [];
	});
	
	Crafty.scene("tutorial", function() {
		menu = Crafty.e("MenuBackground");
		Crafty.e("2D, Canvas, Mouse, Wobble, leftbutton").origin("center").attr({x: 526, y: 437, _menu: menu}).bind("Click", function() {this._menu.turn(-1)})
		Crafty.e("2D, Canvas, Mouse, Wobble, rightbutton").origin("center").attr({x: 592, y:437, _menu: menu}).bind("Click", function() {this._menu.turn(1)})
		Crafty.e("2D, Canvas, Mouse, Wobble, backtomenubutton").origin("center").attr({x: 26, y:434, _menu: menu}).bind("Click", function() {Crafty.scene("setup")}).Wobble(1,12.25)
	});
	Crafty.c("MenuBackground", {
		_page: 0,
		_pages: ["sprites/tutorial_page1_01.jpg","sprites/tutorial_page2_01.jpg","sprites/tutorial_page3_01.jpg","sprites/tutorial_page4_01.jpg"],
		init: function() {
			this.requires("2D, Canvas, Image");
			this.image(this._pages[this._page]);
		},
		turn: function(dir) {
			this._page+=dir;
			if(this._page<0) {this._page = this._pages.length-1;}
			if(this._page>=this._pages.length) {this._page = 0;}
			this.image(this._pages[this._page]);
		}
	});
	
	Crafty.scene("loading"); 
}

function startPlaying() {
	var num = 2;
	Players = [];
	for(var i = 0; i<num; i++) {
		Players.push({name: "Player "+(i+1), path: undefined, runner: undefined, sprite: "character"+i});
	}
	Crafty.scene("randomize");
}
